Attribute VB_Name = "basCodeSample7"
Option Explicit

Private ins As Outlook.Inspector
'Must declare as object because it might be any type of object
Private itm As Object
Private con As Outlook.ContactItem
Private appAccess As Access.Application
Private fso As Scripting.FileSystemObject
Private fld As Scripting.Folder
Private strAccessPath As String
Private dbe As DAO.DBEngine
Private strDBName As String
Private strDBNameAndPath As String
Private wks As DAO.Workspace
Private dbs As DAO.Database
Private rst As DAO.Recordset
Private ups As Outlook.UserProperties
Private fil As Scripting.File
Private prp As Outlook.UserProperty
Private msg As Outlook.MailItem


Public Sub SaveContactToAccess()
'Created by Helen Feddema 4-Dec-2004
'Last modified 4-Dec-2004

On Error GoTo ErrorHandler

   Set ins = Application.ActiveInspector
   Set itm = ins.CurrentItem
   
   If itm.Class <> olContact Then
      MsgBox "The active Inspector is not a contact item; exiting"
      GoTo ErrorHandlerExit
      'Could add more error-trapping to determine if the mail message uses a
      'specific custom form, or has specific data in one or more fields
   
   Else
      Set con = itm
      
      'Pick up path to Access database directory from Access SysCmd function
      Set appAccess = CreateObject("Access.Application")
      strAccessPath = appAccess.SysCmd(acSysCmdAccessDir)
      strAccessPath = strAccessPath & "Outlook Data\"
      Debug.Print "Access database path: " & strAccessPath
   
      'Check that there is an Outlook Contacts folder under the Access
      'database folder, and exit if not found
      Set fso = CreateObject("Scripting.FileSystemObject")
      Set fld = fso.GetFolder(strAccessPath)
      Set dbe = CreateObject("DAO.DBEngine.36")
      strDBName = "Personal 2000.mdb"
      strDBNameAndPath = strAccessPath & strDBName
      Debug.Print "Database name: " & strDBNameAndPath
   
      'Test for existence of database
      Set fil = fso.GetFile(strDBNameAndPath)
      Set wks = dbe.Workspaces(0)
      Set dbs = wks.OpenDatabase(strDBNameAndPath)
   
      'Open Access table containing contact data
      Set rst = dbs.OpenRecordset("tblContacts")
      rst.AddNew
      
      'Save data from built-in fields to Access table
      If con.Title <> "" Then
         rst!Title = con.Title
      End If
      If con.FirstName <> "" Then
         rst!FirstName = con.FirstName
      End If
      If con.MiddleName <> "" Then
         rst!MiddleName = con.MiddleName
      End If
      If con.LastName <> "" Then
         rst!LastName = con.LastName
      End If
      If con.Suffix <> "" Then
         rst!Suffix = con.Suffix
      End If
      If con.CompanyName <> "" Then
         rst!Company = con.CompanyName
      End If
      If con.JobTitle <> "" Then
         rst!JobTitle = con.JobTitle
      End If
      If con.BusinessAddressStreet <> "" Then
         rst!BusinessStreet = con.BusinessAddressStreet
      End If
      If con.BusinessAddressCity <> "" Then
         rst!BusinessCity = con.BusinessAddressCity
      End If
      If con.BusinessAddressState <> "" Then
         rst!BusinessState = con.BusinessAddressState
      End If
      If con.BusinessAddressPostalCode <> "" Then
         rst!BusinessPostalCode = con.BusinessAddressPostalCode
      End If
      If con.BusinessAddressCountry <> "" Then
         rst!BusinessCountry = con.BusinessAddressCountry
      End If
      If con.HomeAddressStreet <> "" Then
         rst!HomeStreet = con.HomeAddressStreet
      End If
      If con.HomeAddressCity <> "" Then
         rst!HomeCity = con.HomeAddressCity
      End If
      If con.HomeAddressState <> "" Then
         rst!HomeState = con.HomeAddressState
      End If
      If con.HomeAddressPostalCode <> "" Then
         rst!HomePostalCode = con.HomeAddressPostalCode
      End If
      If con.HomeAddressCountry <> "" Then
         rst!HomeCountry = con.HomeAddressCountry
      End If
      If con.OtherAddressStreet <> "" Then
         rst!OtherStreet = con.OtherAddressStreet
      End If
      If con.OtherAddressCity <> "" Then
         rst!OtherCity = con.OtherAddressCity
      End If
      If con.OtherAddressState <> "" Then
         rst!OtherState = con.OtherAddressState
      End If
      If con.OtherAddressPostalCode <> "" Then
         rst!OtherPostalCode = con.OtherAddressPostalCode
      End If
      If con.OtherAddressCountry <> "" Then
         rst!OtherCountry = con.OtherAddressCountry
      End If
      If con.BusinessFaxNumber <> "" Then
         rst!BusinessFax = con.BusinessFaxNumber
      End If
      If con.BusinessTelephoneNumber <> "" Then
         rst!BusinessPhone = con.BusinessTelephoneNumber
      End If
      If con.Business2TelephoneNumber <> "" Then
         rst!BusinessPhone2 = con.Business2TelephoneNumber
      End If
      If con.CallbackTelephoneNumber <> "" Then
         rst!Callback = con.CallbackTelephoneNumber
      End If
      If con.CarTelephoneNumber <> "" Then
         rst!CarPhone = con.CarTelephoneNumber
      End If
      If con.CompanyMainTelephoneNumber <> "" Then
         rst!CompanyMainPhone = con.CompanyMainTelephoneNumber
      End If
      If con.HomeFaxNumber <> "" Then
         rst!HomeFax = con.HomeFaxNumber
      End If
      If con.HomeTelephoneNumber <> "" Then
         rst!HomePhone = con.HomeTelephoneNumber
      End If
      If con.Home2TelephoneNumber <> "" Then
         rst!HomePhone2 = con.Home2TelephoneNumber
      End If
      If con.ISDNNumber <> "" Then
         rst!ISDN = con.ISDNNumber
      End If
      If con.MobileTelephoneNumber <> "" Then
         rst!MobilePhone = con.MobileTelephoneNumber
      End If
      If con.OtherFaxNumber <> "" Then
         rst!OtherFax = con.OtherFaxNumber
      End If
      If con.OtherTelephoneNumber <> "" Then
         rst!OtherPhone = con.OtherTelephoneNumber
      End If
      If con.PagerNumber <> "" Then
         rst!Pager = con.PagerNumber
      End If
      If con.PrimaryTelephoneNumber <> "" Then
         rst!PrimaryPhone = con.PrimaryTelephoneNumber
      End If
      If con.RadioTelephoneNumber <> "" Then
         rst!RadioPhone = con.RadioTelephoneNumber
      End If
      If con.TTYTDDTelephoneNumber <> "" Then
         rst!TTYTDDPhone = con.TTYTDDTelephoneNumber
      End If
      If con.TelexNumber <> "" Then
         rst!Telex = con.TelexNumber
      End If
      If con.BillingInformation <> "" Then
         rst!BillingInformation = con.BillingInformation
      End If
      If con.Email1Address <> "" Then
         rst!EmailAddress = con.Email1Address
      End If
      If con.Email1DisplayName <> "" Then
         rst!EmailDisplayName = con.Email1DisplayName
      End If
      If con.Email2Address <> "" Then
         rst!Email2Address = con.Email2Address
      End If
      If con.Email2DisplayName <> "" Then
         rst!Email2DisplayName = con.Email2DisplayName
      End If
      If con.Email3Address <> "" Then
         rst!Email3Address = con.Email3Address
      End If
      If con.Email3DisplayName <> "" Then
         rst!Email3DisplayName = con.Email3DisplayName
      End If
      If con.Subject <> "" Then
         rst!Notes = con.Subject
      End If
      If con.WebPage <> "" Then
         rst!WebPage = con.WebPage
      End If
      If con.Categories <> "" Then
         rst!Categories = con.Categories
      End If
      
      'Save data from custom fields to Access table (if they exist)
      Set ups = con.UserProperties
      Set prp = ups.Find("CustomTextField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> "" Then
            rst!CustomTextField = ups("CustomTextField").Value
         End If
      End If
      
      Set prp = ups.Find("CustomDateField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> #1/1/4501# Then
            rst!CustomDateField = ups("CustomDateField").Value
         End If
      End If
      
      Set prp = ups.Find("CustomCurrencyField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> 0 Then
            rst!CustomCurrencyField = prp.Value
         End If
      End If
      
      Set prp = ups.Find("CustomIntegerField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> 0 Then
            rst!CustomIntegerField = prp.Value
         End If
      End If
      
      rst.Update
      rst.Close
      dbs.Close
      Set wks = Nothing
      Set dbe = Nothing
      Set appAccess = Nothing
      
      MsgBox con.FirstName & " " & con.LastName & "'s data exported to tblContacts"
   
   End If
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   If Err.Number = 76 Then
      Set fld = fso.CreateFolder(strAccessPath)
      MsgBox strAccessPath & _
         " folder created; please copy the appropriate Access database to it and try again"
      GoTo ErrorHandlerExit
   Else
      MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
      Resume ErrorHandlerExit
   End If


End Sub

Public Sub SendAndSaveMessageToAccess()
'Created by Helen Feddema 4-Dec-2004
'Last modified 4-Dec-2004

On Error GoTo ErrorHandler
   
   Set ins = Application.ActiveInspector
   Set itm = ins.CurrentItem
   
   If itm.Class <> olMail Then
      MsgBox "The active Inspector is not a mail message; exiting"
      GoTo ErrorHandlerExit
      'Could add more error-trapping to determine if the mail message uses a
      'specific custom form, or has specific data in one or more fields
   
   Else
      Set msg = itm
      
      'Pick up path to Access database directory from Access SysCmd function
      Set appAccess = CreateObject("Access.Application")
      strAccessPath = appAccess.SysCmd(acSysCmdAccessDir)
      strAccessPath = strAccessPath & "Outlook Data\"
      Debug.Print "Access database path: " & strAccessPath
   
      'Check that there is an Outlook Contacts folder under the Access
      'database folder, and exit if not found
      Set fso = CreateObject("Scripting.FileSystemObject")
      Set fld = fso.GetFolder(strAccessPath)
      Set dbe = CreateObject("DAO.DBEngine.36")
      strDBName = "Personal 2000.mdb"
      strDBNameAndPath = strAccessPath & strDBName
      Debug.Print "Database name: " & strDBNameAndPath
   
      'Test for existence of database
      Set fil = fso.GetFile(strDBNameAndPath)
      Set wks = dbe.Workspaces(0)
      Set dbs = wks.OpenDatabase(strDBNameAndPath)
   
      'Open Access table containing mail message data
      Set rst = dbs.OpenRecordset("tblMessages")
      rst.AddNew
      
      'Save data from built-in fields to Access table
      If msg.Subject <> "" Then
         rst!Subject = msg.Subject
      End If
      If msg.CC <> "" Then
         rst!CC = msg.CC
      End If
      If msg.BCC <> "" Then
         rst!BCC = msg.BCC
      End If
      If msg.Body <> "" Then
         rst!Body = msg.Body
      End If
      rst!Sent = Date
      If msg.To <> "" Then
         rst!To = msg.To
      End If
      
      'Save data from custom fields to Access table (if they exist)
      Set ups = msg.UserProperties
      Set prp = ups.Find("CustomTextField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> "" Then
            rst!CustomTextField = ups("CustomTextField").Value
         End If
      End If
      
      Set prp = ups.Find("CustomDateField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> #1/1/4501# Then
            rst!CustomDateField = ups("CustomDateField").Value
         End If
      End If
      
      Set prp = ups.Find("CustomCurrencyField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> 0 Then
            rst!CustomCurrencyField = prp.Value
         End If
      End If
      
      Set prp = ups.Find("CustomIntegerField")
      If TypeName(prp) <> "Nothing" Then
         If prp.Value <> 0 Then
            rst!CustomIntegerField = prp.Value
         End If
      End If
      
      rst.Update
      rst.Close
      dbs.Close
      Set wks = Nothing
      Set dbe = Nothing
      Set appAccess = Nothing
      
      MsgBox msg.Subject & " data exported to tblMessages"
      msg.Send
   
   End If
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   If Err.Number = 76 Then
      Set fld = fso.CreateFolder(strAccessPath)
      MsgBox strAccessPath & _
         " folder created; please copy the appropriate Access database to it and try again"
      GoTo ErrorHandlerExit
   Else
      MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
      Resume ErrorHandlerExit
   End If

End Sub

